<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- FileDetails/Synopsis/Parser.hh.html -->
<!-- this view was generated by FileDetails -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Parser.hh Details</title>
<link href="../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="FileDetails">
<div class="navigation">
<span class="normal"><a href="../../Scopes/global.html" >Global Namespace</a></span>
<span class="normal"><a href="../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../NameIndex.html" >Name Index</a></span>
</div>
<h1 >Synopsis/Parser.hh</h1><div><a href="../../Source/Synopsis/Parser.hh.html" target="content">source code</a></div>
<h2 class="heading">Includes from this file:</h2><ul>
<li>include <a href="PTree.hh.html" >Synopsis/PTree.hh</a></li>
<li>include <a href="SymbolFactory.hh.html" >Synopsis/SymbolFactory.hh</a></li>
</ul>
<h2 class="heading">Declarations in this file:</h2>
<div><h3>Classes in Synopsis</h3>
<div class="item"><a href="../../Scopes/Synopsis/Lexer.html" >Lexer</a>
<div class="doc"><p>a Lexer reads tokens from a stream.</p>
</div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html" >Parser</a>
<div class="doc"><p>C++ Parser</p>
</div></div>

</div>
<div><h3>Classes in Synopsis::Parser</h3>
<div class="item"><a href="../../Scopes/Synopsis/Parser/Error.html" >Error</a>
<div class="doc"><p>Error is used to cache parse errors encountered during the execution
of the parse method.</p>
</div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser/StatusGuard.html" >StatusGuard</a>
<div class="doc"><p>A StatusGuard manages a tentative parse.</p>
</div></div>

</div>
<div><h3>Data members in Synopsis::Parser::StatusGuard</h3>
<div class="item"><a href="../../Scopes/Synopsis/Parser/StatusGuard.html#my_committed" >my_committed</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser/StatusGuard.html#my_error_mark" >my_error_mark</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser/StatusGuard.html#my_errors" >my_errors</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser/StatusGuard.html#my_lexer" >my_lexer</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser/StatusGuard.html#my_token_mark" >my_token_mark</a>
<div class="doc"></div></div>

</div>
<div><h3>Data members in Synopsis::Parser</h3>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#my_comments" >my_comments</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#my_errors" >my_errors</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#my_gt_is_operator" >my_gt_is_operator</a>
<div class="doc"><p>If true, <em>&gt;</em> is interpreted as ther greater-than operator.</p>
</div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#my_in_template_decl" >my_in_template_decl</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#my_lexer" >my_lexer</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#my_ruleset" >my_ruleset</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#my_scope_is_valid" >my_scope_is_valid</a>
<div class="doc"><p>Record whether the current scope is valid.</p>
</div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#my_symbols" >my_symbols</a>
<div class="doc"></div></div>

</div>
<div><h3>Enums in Synopsis::Parser</h3>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#DeclKind" >DeclKind</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#RuleSet" >RuleSet</a>
<div class="doc"><p>RuleSet defines non-standard optional rules that can be chosen at runtime.</p>
</div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#TemplateDeclKind" >TemplateDeclKind</a>
<div class="doc"></div></div>

</div>
<div><h3>Member functions in Synopsis::Parser::Error</h3>
<div class="item"><a href="../../Scopes/Synopsis/Parser/Error.html#write_lstd_mostream_A_rconst" >write&#40;std::ostream&amp;&#41;const</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser/Error.html#_tError_l_r" >~Error&#40;&#41;</a>
<div class="doc"></div></div>

</div>
<div><h3>Member functions in Synopsis::Parser</h3>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#Parser_lLexer_A_cSymbolFactory_A_cint_r" >Parser&#40;Lexer&amp;&#44;SymbolFactory&amp;&#44;int&#41;</a>
<div class="doc"></div></div>

</div>
<div><h3>Member functions in Synopsis::Parser::StatusGuard</h3>
<div class="item"><a href="../../Scopes/Synopsis/Parser/StatusGuard.html#StatusGuard_lParser_A_r" >StatusGuard&#40;Parser&amp;&#41;</a>
<div class="doc"></div></div>

</div>
<div><h3>Member functions in Synopsis::Parser</h3>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#class_body_lPTree_mClassBody_S_A_r" >class_body&#40;PTree::ClassBody*&amp;&#41;</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#class_spec_lPTree_mClassSpec_S_A_cPTree_mEncoding_A_r" >class_spec&#40;PTree::ClassSpec*&amp;&#44;PTree::Encoding&amp;&#41;</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#compound_statement_lPTree_mBlock_S_A_cbool_r" >compound_statement&#40;PTree::Block*&amp;&#44;bool&#41;</a>
<div class="doc"><p>compound-statement:</p>
</div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#const_declaration_lPTree_mDeclaration_S_A_cPTree_mEncoding_A_cPTree_mNode_S_cPTree_mNode_S_r" >const_declaration&#40;PTree::Declaration*&amp;&#44;PTree::Encoding&amp;&#44;PTree::Node*&#44;PTree::Node*&#41;</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#declaration_lPTree_mDeclaration_S_A_r" >declaration&#40;PTree::Declaration*&amp;&#41;</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#declarator_lPTree_mNode_S_A_cDeclKind_cbool_cPTree_mEncoding_A_cPTree_mEncoding_A_cbool_cbool_r" >declarator&#40;PTree::Node*&amp;&#44;DeclKind&#44;bool&#44;PTree::Encoding&amp;&#44;PTree::Encoding&amp;&#44;bool&#44;bool&#41;</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#declarator2_lPTree_mNode_S_A_cDeclKind_cbool_cPTree_mEncoding_A_cPTree_mEncoding_A_cbool_cbool_cPTree_mNode_S_S_r" >declarator2&#40;PTree::Node*&amp;&#44;DeclKind&#44;bool&#44;PTree::Encoding&amp;&#44;PTree::Encoding&amp;&#44;bool&#44;bool&#44;PTree::Node**&#41;</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#definition_lPTree_mNode_S_A_r" >definition&#40;PTree::Node*&amp;&#41;</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#enum_spec_lPTree_mEnumSpec_S_A_cPTree_mEncoding_A_r" >enum_spec&#40;PTree::EnumSpec*&amp;&#44;PTree::Encoding&amp;&#41;</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#function_body_lPTree_mBlock_S_A_r" >function_body&#40;PTree::Block*&amp;&#41;</a>
<div class="doc"><p>function-body:</p>
</div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#init_declarator_list_lPTree_mNode_S_A_cPTree_mEncoding_A_cbool_cbool_r" >init_declarator_list&#40;PTree::Node*&amp;&#44;PTree::Encoding&amp;&#44;bool&#44;bool&#41;</a>
<div class="doc"><p>[gram.dcl.decl]</p>
</div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#integral_declaration_lPTree_mDeclaration_S_A_cPTree_mEncoding_A_cPTree_mNode_S_cPTree_mNode_S_cPTree_mNode_S_r" >integral_declaration&#40;PTree::Declaration*&amp;&#44;PTree::Encoding&amp;&#44;PTree::Node*&#44;PTree::Node*&#44;PTree::Node*&#41;</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#is_allocate_expr_lToken_mType_r" >is_allocate_expr&#40;Token::Type&#41;</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#is_ptr_to_member_lint_r" >is_ptr_to_member&#40;int&#41;</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#maybe_typename_or_class_template_lToken_A_r" >maybe_typename_or_class_template&#40;Token&amp;&#41;</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#namespace_alias_lPTree_mNamespaceAlias_S_A_r" >namespace_alias&#40;PTree::NamespaceAlias*&amp;&#41;</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#namespace_spec_lPTree_mNamespaceSpec_S_A_r" >namespace_spec&#40;PTree::NamespaceSpec*&amp;&#41;</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#new_declarator_lPTree_mDeclarator_S_A_cPTree_mEncoding_A_r" >new_declarator&#40;PTree::Declarator*&amp;&#44;PTree::Encoding&amp;&#41;</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#opt_integral_type_or_class_spec_lPTree_mNode_S_A_cPTree_mEncoding_A_r" >opt_integral_type_or_class_spec&#40;PTree::Node*&amp;&#44;PTree::Encoding&amp;&#41;</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#origin_lconst.char_S_cstd_mstring_A_rconst" >origin&#40;const&#160;char*&#44;std::string&amp;&#41;const</a>
<div class="doc"><p>Return the origin of the given pointer
(filename and line number)</p>
</div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#parameter_declaration_lPTree_mParameterDeclaration_S_A_cPTree_mEncoding_A_r" >parameter_declaration&#40;PTree::ParameterDeclaration*&amp;&#44;PTree::Encoding&amp;&#41;</a>
<div class="doc"><p>parameter-declaration:</p>
</div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#parameter_declaration_list_or_init_lPTree_mNode_S_A_cbool_A_cPTree_mEncoding_A_cbool_r" >parameter_declaration_list_or_init&#40;PTree::Node*&amp;&#44;bool&amp;&#44;PTree::Encoding&amp;&#44;bool&#41;</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#show_message_head_lconst.char_S_r" >show_message_head&#40;const&#160;char*&#41;</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#template_decl2_lPTree_mTemplateDecl_S_A_cTemplateDeclKind_A_r" >template_decl2&#40;PTree::TemplateDecl*&amp;&#44;TemplateDeclKind&amp;&#41;</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#template_parameter_list_lPTree_mList_S_A_r" >template_parameter_list&#40;PTree::List*&amp;&#41;</a>
<div class="doc"><p>template-parameter-list:</p>
</div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#type_specifier_lPTree_mNode_S_A_cbool_cPTree_mEncoding_A_r" >type_specifier&#40;PTree::Node*&amp;&#44;bool&#44;PTree::Encoding&amp;&#41;</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#typedef__lPTree_mTypedef_S_A_r" >typedef_&#40;PTree::Typedef*&amp;&#41;</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#using_declaration_lPTree_mUsingDeclaration_S_A_r" >using_declaration&#40;PTree::UsingDeclaration*&amp;&#41;</a>
<div class="doc"></div></div>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#using_directive_lPTree_mUsingDirective_S_A_r" >using_directive&#40;PTree::UsingDirective*&amp;&#41;</a>
<div class="doc"></div></div>

</div>
<div><h3>Member function templates in Synopsis::Parser</h3>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#declare_lT_S_r" >declare&#40;T*&#41;</a>
<div class="doc"></div></div>

</div>
<div><h3>Structs in Synopsis::Parser</h3>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#ScopeGuard" >ScopeGuard</a>
<div class="doc"></div></div>

</div>
<div><h3>Typedefs in Synopsis::Parser</h3>
<div class="item"><a href="../../Scopes/Synopsis/Parser.html#ErrorList" >ErrorList</a>
<div class="doc"></div></div>
</div>

</body>
</html>
